<?php

require_once 'base/GepProdutofluxoEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 *
 * @package Entity
 * @author  Setforms
 */
class GepProdutofluxoEntity extends GepProdutofluxoEntityBase
{


    CONST SEM_PRODUTO = '10';
    CONST NO_DATA = '20';


    /**
     * Gera novo c?o de Produto por Tipo de Fluxo.
     *
     * @param integer $nrorg N?o da Organiza?.
     *
     * @return $codigo integer
     */
    public static function retornaProxNumeroProdutoFluxo($nrorg){
        $codigo = Novocodigo::geraCodigo($nrorg, 'GEP_PRODUTOFLUXO', 10);
        return $codigo;
    }


    /**
     * Retorna consulta de produtos por tipo de fluxo.
     *
     * @param integer $nrorg   Numero da organizacao.
     * @param integer $tpfluxo Numero de tipo de fluxo.
     *
     * @return string $resultado
     */
    public function dadosProdutosFluxo($nrorg, $tpfluxo){
        $resultado = GepProdutofluxo::consultaProdutosFluxo($nrorg, $tpfluxo);

        if (is_array($resultado)) {
            return $resultado;
        }

        throw new Exception(
            'GepProdutofluxoEntity: Nao ha produtos parametrizado para este tipo de fluxo',
            self::SEM_PRODUTO
        );

    }


    public function salvaProdutoFluxo(array $param) {
        try {
            $entity = new self();

            $entity->setNrprodutofluxo($param['NRPRODUTOFLUXO']);
            $entity->setNrtipofluxo($param['NRTIPOFLUXO']);
            $entity->setCdproduto($param['CDPRODUTO']);
            $entity->setNrorg($param['NRORG']);
            $entity->setIdativo($param['IDATIVO']);
            $entity->setDtinclusao($param['DTINCLUSAO']);
            $entity->setDtultatu($param['DTULTATU']);
            $entity->setNrorginclusao($param['NRORGINCLUSAO']);
            $entity->setCdoperinclusao($param['CDOPERINCLUSAO']);
            $entity->setNrorgultatu($param['NRORGULTATU']);
            $entity->setCdoperultatu($param['CDOPERULTATU']);

            $entity->persist();
            return true;
        } catch (Exception $e) {
            return false;
        }
    }


    public function dadosProdutoFluxo($nrorg, $tpfluxo, $cdproduto){
        $resultado = GepProdutofluxo::consultaProdutoFluxo($nrorg, $tpfluxo, $cdproduto);

        if ($resultado instanceof GepProdutofluxoEntity) {
            return $resultado;
        }

        throw new Exception(
            'GepProdutofluxoEntity: Este produto nao existe.',
            self::SEM_PRODUTO
        );

    }


}